Subject: [netmod] [Incoming] AD review of draft-ietf-netmod-factory-default-12

From: "Rob Wilton (rwilton)" <[email-masked]>
Date: Mon, 24 Feb 2020 16:04:43 +0000

Hi,

Thanks for writing this document.  I found this document to be well written, clear and understandable.  However, there are a few issues which I think could be addressed before kicking off IETF LC.

I have the following comments:

  1.  Title: The title of the document may be clearer as: "A YANG Data Model for Factory Default Settings".

  1.  Abstract: I would suggest condensing the abstract, which is currently very similar to the introduction, perhaps to the following text:

 "This document defines a YANG data model to allow clients to

  reset a server back to its factory default condition.  It

  also defines a "factory-default" datastore to allow clients

  to read the factory default configuration for the device.

  The YANG data model in this document conforms to the Network

  Management Datastore Architecture (NMDA) defined in RFC 8342<https://tools.ietf.org/html/rfc8342>.
   "

  1.  Introduction: It might be useful to include instructions for the RFC editor at the beginning of the introduction to summarize what actions are required before publication.

  1.  Terminology (section 1.1).   For the definition of the factory-default datastore, I would add the sentence "This datastore is referred to as "<factory-default>."

  1.  Terminology (section 1.1).  I propose that you also important the term "datastore schema" from RFC 8342, for use with a proposed update to section 3.

  1.  Section 2, third bullet.  It might be better to replace "ephemeral datastores" with "dynamic configuration datastores", since that is the reference is RFC 8342.

  1.  Section 3, first paragraph.  I suggest removing the word minimal, i.e. "preconfigured minimal initial configuration" => "preconfigured initial configuration", since it isn't required that the factory default configuration is minimal, although it would normally be so.

  1.  Section 3. I think that the document must define what the schema is for the "factory-default".  Hence, rather than "YANG modules: all", perhaps "YANG modules: The factory default datastore schema MUST either be the same as the conventional configuration datastores, or a subset of the datastore schema for the conventional configuration datastores."

  1.  Section 3. Probably add the following sentence to the end of section 3: "If supported, the factory-default datastore MUST be included in the list of datastores in YANG library [RFC 8525]."  This would probably also add RFC 8525 as a normative reference.

  1.  YANG module, rpc factory-reset description.  I suggest changing the description to

"The server resets all datastores to their factory default content and any non-volatile storage back to factory condition, deleting all dynamically generated files, including those containing keys, certificates, logs, and other temporary files.

Depending on the factory default configuration, after being reset, the device may become unreachable on the network."

  1.  I think that the security section needs to explicitly mention that non volatile storage is expected to be wiped clean and reset back to the factory default state, but that there is no guarantee that the data is wiped to any particular data cleansing particular standard, and the owner of the device MUST NOT rely on any temporary data (e.g., including private keys) being unrecoverable after the factory-reset RPC has been invoked.

Nits:

Section 2:
"are all reset to" => "are reset to"
"datastores(e.g. " => "datastores (e.g., "

Section 3:
"with <operational> => "with the <operational>".

Section 7: ", Susan Hares to review this draft and provide important input to this document" => ", and Susan Hares for reviewing this document and providing important input".

Regards,
Rob

---

From: Qin Wu <[email-masked]>
Date: Tue, 25 Feb 2020 12:12:10 +0000

Thanks Rob for clarification. I will post the new version based on your review suggestions soon.

-Qin
发件人: Rob Wilton (rwilton) [mailto:[email-masked]]
发送时间: 2020年2月25日 20:10
收件人: Qin Wu <[email-masked]>; [email-masked]; [email-masked]
抄送: Warren Kumari <[email-masked]>
主题: RE: [Incoming] AD review of draft-ietf-netmod-factory-default-12

Hi Qin,

From: Qin Wu <[email-masked]<mailto:[email-masked]>>
Sent: 25 February 2020 10:44
To: Rob Wilton (rwilton) <[email-masked]<mailto:[email-masked]>>; [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>
Cc: Warren Kumari <[email-masked]<mailto:[email-masked]>>
Subject: RE: [Incoming] AD review of draft-ietf-netmod-factory-default-12

HI, Rob:
发件人: Rob Wilton (rwilton) [mailto:[email-masked]]
发送时间: 2020年2月25日 18:23
收件人: Qin Wu <[email-masked]<mailto:[email-masked]>>; [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>
抄送: Warren Kumari <[email-masked]<mailto:[email-masked]>>
主题: RE: [Incoming] AD review of draft-ietf-netmod-factory-default-12

Hi Qin,

Thanks for getting back to be me quickly.  Please see [RW] inline …

From: Qin Wu <[email-masked]<mailto:[email-masked]>>
Sent: 25 February 2020 02:22
To: Rob Wilton (rwilton) <[email-masked]<mailto:[email-masked]>>; [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>
Cc: Warren Kumari <[email-masked]<mailto:[email-masked]>>
Subject: RE: [Incoming] AD review of draft-ietf-netmod-factory-default-12

Thanks Rob for good review and proposed text, I will incorporate them in v-13, the only comment I am not sure is comment 3, I have nothing to add for instruction for RFC editor besides
RFC Editor note in the YANG data model code to remind the RFC Editor to replace RFC xxx and related date to actual RFC number and publication date respectively.
[RW]
I think that’s fine, it just means the instructions for the RFC editor can be very short.

But there a couple of other considerations for the RFC editor:

-          Do we expect that the date of the YANG module to also be updated to when it is published?
[Qin]: Yes, I prefer to add RFC Editor Note in the YANG module code with the following format in section 4.
      // RFC Ed.: update the date below with the date of RFC publication
      // and remove this note.
      // RFC Ed.: replace XXXX with actual RFC number and remove this
      // note.

-          There is also a request to the RFC editor that appendix A be deleted before publication.
[Qin]: Yes, we have added RFC Editor note at the beginning of Appendix and remind RFC Editor to delete change log section.

Do you think we should repeat and emphasize these RFC Editor note at the beginning of introduction section?
[RW]
I wasn’t suggesting you repeat the specific text but highlight the sections/things that the RFC editor needs to check for, since I see that it does no harm, and I’ve seen others suggest in prior reviews that this is helpful.  Having checked with an existing AD, there doesn’t seem to be common precedent for how to add RFC editor instructions, so I’ll leave it to your discretion whether to highlight these in the introduction or keep with what you have.

Thanks,
Rob

-Qin
发件人: Rob Wilton (rwilton) [mailto:[email-masked]]
发送时间: 2020年2月25日 0:05
收件人: [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>
抄送: Warren Kumari <[email-masked]<mailto:[email-masked]>>
主题: [Incoming] AD review of draft-ietf-netmod-factory-default-12

Hi,

  1.  Title: The title of the document may be clearer as: “A YANG Data Model for Factory Default Settings”.

 “This document defines a YANG data model to allow clients to

  also defines a “factory-default” datastore to allow clients

   ”

  1.  Terminology (section 1.1).   For the definition of the factory-default datastore, I would add the sentence “This datastore is referred to as "<factory-default>.”

  1.  Terminology (section 1.1).  I propose that you also important the term “datastore schema” from RFC 8342, for use with a proposed update to section 3.

  1.  Section 2, third bullet.  It might be better to replace “ephemeral datastores” with “dynamic configuration datastores”, since that is the reference is RFC 8342.

  1.  Section 3, first paragraph.  I suggest removing the word minimal, i.e. “preconfigured minimal initial configuration” => “preconfigured initial configuration”, since it isn’t required that the factory default configuration is minimal, although it would normally be so.

  1.  Section 3. I think that the document must define what the schema is for the “factory-default”.  Hence, rather than “YANG modules: all”, perhaps “YANG modules: The factory default datastore schema MUST either be the same as the conventional configuration datastores, or a subset of the datastore schema for the conventional configuration datastores.”

  1.  Section 3. Probably add the following sentence to the end of section 3: “If supported, the factory-default datastore MUST be included in the list of datastores in YANG library [RFC 8525].”  This would probably also add RFC 8525 as a normative reference.

“The server resets all datastores to their factory default content and any non-volatile storage back to factory condition, deleting all dynamically generated files, including those containing keys, certificates, logs, and other temporary files.

Depending on the factory default configuration, after being reset, the device may become unreachable on the network.”

Nits:

Section 2:
“are all reset to” => “are reset to”
“datastores(e.g. “ => “datastores (e.g., “

Section 3:
“with <operational> => “with the <operational>”.

Section 7: “, Susan Hares to review this draft and provide important input to this document” => “, and Susan Hares for reviewing this document and providing important input”.

Regards,
Rob